<template>
    <form class="container" v-on:submit.prevent="submit()">
        <div class="col-12">
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>N° de contrat
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="numContrat" v-model="project.facture.numContrat" required>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Client
                            <span>*</span>
                        </label>
                        <select class="form-control" type="text" name="client" v-model="project.facture.client" required>
                            <option v-for="client in clients" v-bind:value="client._id">
                                {{client.firstname}} {{client.lastname}}
                            </option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Montant HT
                            <span>*</span>
                        </label>
                        <input class="form-control" type="number" name="ht" v-model="project.facture.ht" required>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Montant TTC
                            <span>*</span>
                        </label>
                        <input class="form-control" type="number" name="ttc" v-model="project.facture.ttc" required>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>TVA
                            <span>*</span>
                        </label>
                        <input class="form-control" type="number" name="tva" v-model="project.facture.tva" required>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Status
                            <span>*</span>
                        </label>
                        <select class="form-control" type="text" name="client" v-model="project.facture.status" required>
                            <option value="Ajouté">
                                Ajouté
                            </option>
                            <option value="Envoyé">
                                Envoyé
                            </option>
                            <option value="Annulé">
                                Annulé
                            </option>
                            <option value="Impayé">
                                Impayé
                            </option>
                            <option value="Payé">
                                Payé
                            </option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Date
                            <span>*</span>
                        </label>
                        <DatePicker v-model="project.facture.date" input-class="form-control"></DatePicker>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Delait de Payement
                            <span>*</span>
                        </label>
                        <input class="form-control" type="text" name="delay" v-model="project.facture.delay" required>
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-6">
                    <div class="form-group">
                        <label>Commentaire
                            <span>*</span>
                        </label>
                        <textarea class="form-control" v-model="project.facture.comment"></textarea>
                    </div>
                </div>
                <div class="col-6">
                    <div class="form-group">
                        <label>Manager
                            <span>*</span>
                        </label>
                        <select class="form-control" type="text" name="client" v-model="project.facture.manager" required>
                            <option v-for="manager in managers" v-bind:value="manager._id">
                                {{manager.firstname}} {{manager.lastname}}
                            </option>
                        </select>
                    </div>
                </div>
            </div>
            <div class="col-12">
                <div class="form-group">
                    <button class="btn btn-primary" type="submit"> Sauvegarder </button>
                    <button class="btn btn-secondary" type="button" v-on:click="back()"> Retour </button>
                </div>
            </div>
        </div>
    </form>
</template>

<script>
import { editProject } from '@/api/projects.service.js';
import DatePicker from 'vuejs-datepicker';
export default {
    computed: {
        project() {
            if (this.$store.getters.getCurrentProject.facture) {
                return this.$store.getters.getCurrentProject;
            }
            return { facture: {} };
        },
        clients() {
            return this.$store.getters.getAllClients;
        },
        managers() {
            return this.$store.getters.getAllDevelopers;
        }
    },
    methods: {
        submit: function () {
            let id = this.project._id;
            this.project.facture.project = this.project.title;
            editProject(id, this.project).then(() => {
                this.$router.go(-1);
            });
        },
        back: function () {
            this.$router.go(-1);
        }
    },
    created() {
        this.$store.dispatch('setAllClients');
        this.$store.dispatch('setProjectById', this.$route.params.id).then(() => {
            if (!this.project.facture) {
                this.project.facture = new Object();
                let id = this.project._id;
                editProject(id, this.project);
            }
        });
    },
    components: {
        DatePicker
    }
}
</script>

<style scoped>
span {
    color: red;
}

.wider {
    width: 30px;
    height: 30px;
}
</style>
